//******************************************************************************
// carui.java:	Applet
//
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.*;

//==============================================================================
// Main Class for applet carui
//
//==============================================================================
public class carui extends Applet
{

	Image uiImage1;
	Image uiImage2;
	Vector bRects;
	Vector bStrings;
	PrintStream sockout;
	DataInputStream sockin;
	Socket socket;
	String errURL;
	int nButtons;
	int state;
	int port;

	// carui Class Constructor
	//--------------------------------------------------------------------------
	public carui()
	{
		// TODO: Add constructor code here
	}

	// APPLET INFO SUPPORT:
	//		The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    //--------------------------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: carui\r\n" +
		       "Author: Mike Wilbur\r\n" +
		       "Created with Microsoft Visual J++ Version 1.1";
	}


	// The init() method is called by the AWT when an applet is first loaded or
	// reloaded.  Override this method to perform whatever initialization your
	// applet needs, such as initializing data structures, loading images or
	// fonts, creating frame windows, setting the layout manager, or adding UI
	// components.
    //--------------------------------------------------------------------------
	public void init()
	{
        // If you use a ResourceWizard-generated "control creator" class to
        // arrange controls in your applet, you may want to call its
        // CreateControls() method from within this method. Remove the following
        // call to resize() before adding the call to CreateControls();
        // CreateControls() does its own resizing.
        //----------------------------------------------------------------------
    	resize(112, 120);

		uiImage1 = getImage(getCodeBase(),"carui1.gif");
		uiImage2 = getImage(getCodeBase(),"carui2.gif");

		bRects = new Vector(10);
		bStrings = new Vector(10);

		bRects.addElement(new Rectangle(0,0,1,1));   // front left
		bStrings.addElement(new String("XX"));
		bRects.addElement(new Rectangle(0,0,36,36));   // front left
		bStrings.addElement(new String("FL"));
		bRects.addElement(new Rectangle(37,0,36,36));  // front 
		bStrings.addElement(new String("F"));
		bRects.addElement(new Rectangle(73,0,39,36));  // front right
		bStrings.addElement(new String("FR"));
		bRects.addElement(new Rectangle(37,43,36,36)); // Stop
		bStrings.addElement(new String("S"));
		bRects.addElement(new Rectangle(0,84,36,36));  // back left
		bStrings.addElement(new String("BL"));
		bRects.addElement(new Rectangle(37,84,36,36)); // back
		bStrings.addElement(new String("B"));
		bRects.addElement(new Rectangle(73,84,39,36)); // back right
		bStrings.addElement(new String("BR"));

		nButtons = 8;
		state = 0;

		port = new Integer(getParameter("PORT")).intValue();

		errURL = getParameter("ERRURL");
		initSocket();
		// TODO: Place additional initialization code here
	}

	// Place additional applet clean up code here.  destroy() is called when
	// when you applet is terminating and being unloaded.
	//-------------------------------------------------------------------------
	public void destroy()
	{
		// TODO: Place applet cleanup code here
	}

	// carui Paint Handler
	//--------------------------------------------------------------------------
	public void paint(Graphics g)
	{
		Rectangle r;
		g.drawImage(uiImage1,0,0,this);
		if (state > 0) {
//			g.drawString((String)bStrings.elementAt(state),0,50);
			r = (Rectangle)bRects.elementAt(state);
			g.clipRect(r.x,r.y,r.width,r.height);
			g.drawImage(uiImage2,0,0,this);
		}
	}

	//		The start() method is called when the page containing the applet
	// first appears on the screen. The AppletWizard's initial implementation
	// of this method starts execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void start()
	{
		// TODO: Place additional applet start code here
	}
	
	//		The stop() method is called when the page containing the applet is
	// no longer on the screen. The AppletWizard's initial implementation of
	// this method stops execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void stop()
	{
		try {
			socket.close();
		} catch (Exception e) {}
	}


	public boolean mouseDown (Event e, int x, int y) {
		int i;
		for (i=0;i<nButtons;i++) {
			if (((Rectangle) bRects.elementAt(i)).inside(x,y)) {
				state = i;
				sendText("P:"+(String)bStrings.elementAt(state)+"\n");
				repaint();
			}
		}
		return true;
	}
	public boolean mouseUp (Event e, int x, int y) {
		if (state > 0 ) {
			sendText("R:"+(String)bStrings.elementAt(state)+"\n");
			state = 0;
			repaint();
		}
		return true;
	}

	void initSocket() 
	{
		String str;
		try {
			socket = new Socket(getCodeBase().getHost(),port);
		} catch(Exception e) {error();}
		try {
			sockin = new DataInputStream ( socket.getInputStream());
		} catch(Exception e) {error();}
		try {
			sockout = new PrintStream( socket.getOutputStream());
		} catch (Exception e) {error();}
		try {
			str = sockin.readLine();
			if (str.startsWith("IN USE")) {error();}
		} catch (Exception e) {}
	}
	public void sendText(String str) {
		byte bytebuff[]= new byte[2048];
		try {
			str.getBytes(0,str.length(),bytebuff,0);
			sockout.write(bytebuff,0,str.length());
			sockout.flush();
		} catch (Exception e) {error();}
	}

	public void error() {
		try {
			getAppletContext().showDocument(new URL(errURL));
		} catch (Exception e) {}
	}
	// TODO: Place additional applet code here

}
